/*
 *	GG2Stats Message
 *	Author: WoodNeck
 *	If you having any problems, please contact me via steam:
 *	http://steamcommunity.com/id/woodneck/
 *	or E-mail:
 *	saiyu915@naver.com
 */
 
//Declaring global variables
globalvar GG2StatsM;
GG2StatsM = id;
GG2StatsM.packetID = argument1;
GG2StatsM.loginBuffer = buffer_create();
GG2StatsM.basehttp = "https://gg2statsapp.appspot.com";

//Host Process Message
if (global.isHost)
{
	object_event_add(PlayerControl, ev_step, ev_step_begin, "
		if !instance_exists(gg2mMessageHandler)
			instance_create(0,0,gg2mMessageHandler);
	");

	//Attempts log-in to server
	if (!variable_global_exists('gg2mMessageHandler'))
	{
		globalvar gg2mMessageHandler;
		gg2mMessageHandler = object_add();
		object_event_add(gg2mMessageHandler, ev_step, ev_step_end, "
			//Host processing message
			if (global.isHost)
			{
				while(PluginPacketGetBuffer(GG2StatsM.packetID) != -1) {
					_buffer = PluginPacketGetBuffer(GG2StatsM.packetID);
					_player = PluginPacketGetPlayer(GG2StatsM.packetID);
					if (_player == -1 || !instance_exists(_player))
						break;
					switch(read_ubyte(_buffer))
					{
						//User say hello with own unique key
						case 0:
							playerKey = read_string(_buffer, buffer_size(_buffer));
							if (playerKey != '')
							{
								ds_queue_enqueue(gg2mHttpHandler.http_queue, playerKey);
								ds_queue_enqueue(gg2mHttpHandler.http_queue, _player.name);
							}
							break;
						default:
                						write_ubyte(_player.socket, KICK);
                						write_ubyte(_player.socket, KICK_BAD_PLUGIN_PACKET);
                						socket_destroy(_player.socket);
                						_player.socket = -1;
					}
					buffer_clear(_buffer);
					PluginPacketPop(GG2StatsM.packetID);
				}
			}
		");
	
		//here comes the new challenger
		object_event_add(gg2mMessageHandler, ev_other, ev_user0, "
			var message;
			player_name = ds_list_find_value(body_list, 0);
			player_rank = ds_list_find_value(body_list, 1);
			player_point = ds_list_find_value(body_list, 2);
			message = string(player_name) + ' came to server(GG2S-rank: ' + string(player_rank) + ', point: ' +  string(player_point) + ')';
			ServerMessageString(message,global.sendBuffer);
			with NoticeO instance_destroy();
			notice = instance_create(0, 0, NoticeO);
			notice.notice = NOTICE_CUSTOM;
			notice.message = message;
			alarm[0] = 90/global.delta_factor;
		");
	
		//and his hello message
		object_event_add(gg2mMessageHandler, ev_alarm, 0, "
			var message;
			player_name = ds_list_find_value(body_list, 0);
			player_message = ds_list_find_value(body_list, 3);
			message = string(player_name) + ' says: ' + string(player_message);
			ServerMessageString(message,global.sendBuffer);
			with NoticeO instance_destroy();
			notice = instance_create(0, 0, NoticeO);
			notice.notice = NOTICE_CUSTOM;
			notice.message = message;
			ds_list_destroy(body_list);
		");
	
	}

	//Http Handler
	if !variable_global_exists('httpHandler')
	{
		globalvar gg2mHttpHandler ;
		gg2mHttpHandler  = object_add();
		object_event_add(PlayerControl, ev_step, ev_step_begin, "
			if !instance_exists(gg2mHttpHandler)
				instance_create(0,0,gg2mHttpHandler);
		");
		object_event_add(gg2mHttpHandler, ev_create, 0, "
			http_queue = ds_queue_create();
			target = GG2StatsM.basehttp + '/pointview';
			working = false;
		");

		object_event_add(gg2mHttpHandler, ev_destroy, 0, "
			ds_queue_destroy(http_queue);
		");

		object_event_add(gg2mHttpHandler, ev_step, ev_step_begin, "
			if (working)
			{
				//if http page load has done
				if(http_step(connection))
				{
					working = false;
					// page loaded well with code 200
					if (http_status_code(connection) == 200)
					{
						body_str = read_string(http_response_body(connection), http_response_body_size(connection));
						if (body_str != '')//if load fails, page just send out blank page
						{
							body_list = split(body_str, ',');
							ds_list_insert(body_list, 0, paramPlayerName);
							gg2mMessageHandler.body_list = body_list;
							with (gg2mMessageHandler)
							{
								event_user(0); //do notice thing
							}
						}
					}
					http_destroy(connection);
					paramPlayerKey = -1;
					paramPlayerName = -1;
				}
			}
			else
			{
				if (!ds_queue_empty(http_queue))
				{
					working = true;
					paramPlayerKey = ds_queue_dequeue(http_queue);
					paramPlayerName= ds_queue_dequeue(http_queue);
					http_buffer = buffer_create();
					write_string(http_buffer, 'user_key=' + paramPlayerKey);
					connection = http_new_post(target, http_buffer, 'application/x-www-form-urlencoded');
					buffer_destroy(http_buffer);
				}
			}
		");
	}
}
else
{
	//Client say hello to server
	object_event_add(PlayerControl, ev_step, ev_step_begin, "
		if (!variable_local_exists('gg2m_sent'))
			gg2m_sent = false;
		if (!gg2m_sent)
		{
			if (variable_global_exists('unique_key'))
			{
				if (global.unique_key != '')
				{
					write_ubyte(GG2StatsM.loginBuffer, 0);
					write_string(GG2StatsM.loginBuffer, global.unique_key);
					PluginPacketSend(GG2StatsM.packetID, GG2StatsM.loginBuffer);
					buffer_clear(GG2StatsM.packetID);
				}
			}
			gg2m_sent = true;
		}
	");
}